<?php
// Modification for:

/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2005 DanSoft Australia           |
|      http://www.dansoftaustralia.com/        |
\**********************************************/

//File: dostock.php
//      The file to check stock levels and increase, if needed.
//Build 1 (6 April 2007, 14:35, GMT -5)

// A cron job should be set up to run this file every hour.
// This file checks the current shop stock levels, and increases them
// if the appropriate time has come.  Will also decrease to desired
// maximum levels.

if(!isset($_SERVER["HTTP_HOST"])) 
	{

	include("../../SSI.php");
	
	$result = db_query("
			SELECT id, stock, stock_period, stock_add, max_stock, last_stocked
			FROM {$db_prefix}shop_items" , __FILE__, __LINE__);
		
	// There should be multiple rows.
	while ($row = mysql_fetch_assoc($result))
		{
		$id = $row['id']
		$current_stock = $row['stock'];
		$stock_period = $row['stock_period'];
		$stock_add = $row['stock_add'];
		$max_stock = $row['max_stock'];
		$last_stocked = $row['last_stocked'];
		
		if ($stock_period < 1)
			{ // Do not stock this item.
			continue;
			}
		// Check if we need to restock the item.
		$current_time = time();
		$period_seconds = $stock_period * 60 * 60; // 60 seconds by 60 minutes by hours.
		if ($current_time >= $last_stocked + $period_seconds)
			{
			// We have passed our stock period.
			// Check to see if our current stock is less than we're willing to keep around.
			if ($current_stock < $max_stock)
				{
				// It is, so add some.
				$current_stock = $current_stock + $stock_add;
				} // if ($current_stock < $max_stock)
			} // if ($current_time >= $last_stocked + $period_seconds)	
		// Now make sure we're not over the most we want to hold.
		$current_stock = $current_stock > $max_stock ? $max_stock : $current_stock; // Limit to max stock.
					
		// Update the table with the new information.
		$result2 = db_query ("
			UPDATE {$db_prefix}shop_items
			SET stock = {$current_stock},
				last_stocked={$current_time}
			WHERE id=$id" , __FILE__, __LINE__);

		// Sanity check on table update?
		// if (mysql_affected_rows ($result2) != 1) echo 'ERROR DETECTED<br>';
		// This is set to be a cron, so no output needed.  Sanity check skipped.
				
		mysql_free_result($result2);
		} // while ($row = mysql_fetch_assoc($result))
	
	mysql_free_result($result);
	
	} // if(!isset($_SERVER["HTTP_HOST"])) 
?>
